''
'' full colour VGA (4 pixels/hub window) - demo feeder, experimental
''
''        Author: Marko Lukat
'' Last modified: 2011/12/05
''       Version: 0.1
''
'' long[par][0]: double (scan line) buffer -> zero (ready)
'' long[par][1]: writer mailbox
'' long[par][2]: unused
'' long[par][3]: unused
''
OBJ
  system: "core.con.system"
  
VAR
  long  feed[4]
  long  eins[lcnt], zwei[lcnt]
  
PUB null
'' This is not a top level object.

PUB init(ID, mailbox)

  feed{0} := @zwei{0} >< 32 | @eins{0}
  feed[1] := mailbox

  return system.launch(ID, @feeder, @feed{0})
  
DAT             org     0                       ' cog binary header

header_2048     long    system#ID_2             ' magic number for a cog binary
                word    header_size             ' header size
                word    %00000000_00000000      ' flags
                word    0, 0                    ' start register, register count

header_size     fit     16
                
DAT             org     0

feeder          add     temp, par               ' @long[par][1]
                rdlong  scan, par               ' double buffer
                rdword  temp, temp              ' target mailbox
                wrlong  zero, par               ' up and running
                
                add     sync, temp              ' frame indicator
                add     link, temp              ' secondary buffer
                rev     link, #{32-}0
                add     link, temp              ' primary buffer

' The writer (secondary pixel generator) writes its next waitcnt target to the frame
' indicator just before it starts with the vertical blank sequence. This value differs
' at least in bit 0 from a sample taken immediately after a hubop (4n).

                mov     rcnt, cnt               ' |
                wrlong  rcnt, sync              ' |
                rdlong  temp, sync              ' |
                cmp     rcnt, temp wz           ' |
        if_e    jmp     #$-2                    ' sync to vblank
        
' This is just a simple demo. We draw a solid bar of 40 lines and noise
' for the remainder.

screen          mov     rcnt, #40

:eins           rdlong  temp, link wz           ' buffer slot empty?
        if_nz   jmp     #$-1                    ' try again

                mov     addr, scan              ' temp copy
                mov     ecnt, #lcnt             ' element count
:zwei           wrlong  bcol, addr              ' |
                add     addr, #4                ' |
                djnz    ecnt, #:zwei            ' fill scan buffer with solid colour

                wrlong  scan, link              ' displace buffer

                rev     scan, #{32-}0           ' |
                rev     link, #{32-}0           ' swap buffers and slots

                djnz    rcnt, #:eins            ' repeat

' ... now for the noise

                mov     rcnt, #260 -1{scroll}

:drei           rdlong  temp, link wz           ' buffer slot empty?
        if_nz   jmp     #$-1                    ' try again

                mov     addr, scan              ' temp copy
                mov     ecnt, #lcnt             ' element count

:vier           shl     lfsr, #1 wc             ' |
        if_c    xor     lfsr, signature         ' iterate noise

                mov     temp, lfsr              ' |
                and     temp, mask              ' mask colours
                wrlong  temp, addr              ' |
                add     addr, #4                ' |
                djnz    ecnt, #:vier            ' fill scan buffer with noise

                wrlong  scan, link              ' displace buffer

                rev     scan, #{32-}0           ' |
                rev     link, #{32-}0           ' swap buffers and slots

                djnz    rcnt, #:drei            ' repeat

                jmp     #screen                 ' next frame

                
bcol            long    $F00000F0               ' |
mask            long    $54545454               ' stay clear of sync bits

lfsr            long    42                      ' |
signature       long    $1D872B41               ' noise generator

sync            long    12                      ' frame indicator
link            long    4 >< 32 | 8             ' primary/secondary buffer slots
temp            long    4

scan            res     1                       ' primary/secondary buffer address
addr            res     1

ecnt            res     1
rcnt            res     1

                fit

CON
  zero = $1F0                                   ' par (dst only)
  lcnt =  100                                   ' longs per scan line

DAT